blob: 13490c46e4405d674fdc3f27fec68af30d96b756 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
35
36run_args=""
37usage="no"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070038sequental="no"
jeffhao5d1ac922011-09-29 17:41:15 -070039
40while true; do
41 if [ "x$1" = "x--host" ]; then
42 run_args="${run_args} --host"
43 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080044 elif [ "x$1" = "x--jvm" ]; then
45 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -070046 shift
jeffhao5d1ac922011-09-29 17:41:15 -070047 elif [ "x$1" = "x--debug" ]; then
48 run_args="${run_args} --debug"
49 shift
50 elif [ "x$1" = "x--zygote" ]; then
51 run_args="${run_args} --zygote"
52 shift
jeffhao0dff3f42012-11-20 15:13:43 -080053 elif [ "x$1" = "x--interpreter" ]; then
54 run_args="${run_args} --interpreter"
55 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -080056 elif [ "x$1" = "x--jit" ]; then
57 run_args="${run_args} --jit"
58 shift
jeffhao5d1ac922011-09-29 17:41:15 -070059 elif [ "x$1" = "x--no-verify" ]; then
60 run_args="${run_args} --no-verify"
61 shift
62 elif [ "x$1" = "x--no-optimize" ]; then
63 run_args="${run_args} --no-optimize"
64 shift
65 elif [ "x$1" = "x--valgrind" ]; then
66 run_args="${run_args} --valgrind"
67 shift
68 elif [ "x$1" = "x--dev" ]; then
69 run_args="${run_args} --dev"
70 shift
71 elif [ "x$1" = "x--update" ]; then
72 run_args="${run_args} --update"
73 shift
74 elif [ "x$1" = "x--help" ]; then
75 usage="yes"
76 shift
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070077 elif [ "x$1" = "x--seq" ]; then
78 sequental="yes"
79 shift
80 elif [ "x$1" = "x-O" ]; then
81 run_args="${run_args} -O"
82 shift
Zheng Xudc8e7322014-05-07 17:07:20 +010083 elif [ "x$1" = "x--64" ]; then
84 run_args="${run_args} --64"
85 shift
Alex Lighte7873ec2014-08-12 09:53:50 -070086 elif [ "x$1" = "x--gcstress" ]; then
87 run_args="${run_args} --gcstress"
88 shift
89 elif [ "x$1" = "x--gcverify" ]; then
90 run_args="${run_args} --gcverify"
91 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +020092 elif [ "x$1" = "x--trace" ]; then
93 run_args="${run_args} --trace"
94 shift
Alex Lighta59dd802014-07-02 16:28:08 -070095 elif [ "x$1" = "x--relocate" ]; then
96 run_args="${run_args} --relocate"
97 shift
98 elif [ "x$1" = "x--no-relocate" ]; then
99 run_args="${run_args} --no-relocate"
100 shift
Alex Light9d722532014-07-22 18:07:12 -0700101 elif [ "x$1" = "x--no-prebuild" ]; then
102 run_args="${run_args} --no-prebuild"
103 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700104 elif [ "x$1" = "x--prebuild" ]; then
105 run_args="${run_args} --prebuild"
106 shift;
Alex Light03a112d2014-08-25 13:25:56 -0700107 elif [ "x$1" = "x--no-dex2oat" ]; then
108 run_args="${run_args} --no-dex2oat"
109 shift;
110 elif [ "x$1" = "x--no-patchoat" ]; then
111 run_args="${run_args} --no-patchoat"
112 shift;
Alex Lightbfac14a2014-07-30 09:41:21 -0700113 elif [ "x$1" = "x--always-clean" ]; then
114 run_args="${run_args} --always-clean"
Goran Jakovljevic79829cb2015-03-27 11:48:25 +0100115 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700116 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700117 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700118 usage="yes"
119 break
120 else
121 break
122 fi
123done
124
125if [ "$usage" = "yes" ]; then
126 prog=`basename $prog`
127 (
128 echo "usage:"
129 echo " $prog --help Print this message."
130 echo " $prog [options] Run all tests with the given options."
131 echo " Options are all passed to run-test; refer to that for " \
132 "further documentation:"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800133 echo " --debug --dev --host --interpreter --jit --jvm --no-optimize"
Alex Lighta59dd802014-07-02 16:28:08 -0700134 echo " --no-verify -O --update --valgrind --zygote --64 --relocate"
Alex Lighte7873ec2014-08-12 09:53:50 -0700135 echo " --prebuild --always-clean --gcstress --gcverify --trace"
Alex Light03a112d2014-08-25 13:25:56 -0700136 echo " --no-patchoat --no-dex2oat"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700137 echo " Specific Runtime Options:"
138 echo " --seq Run tests one-by-one, avoiding failures caused by busy CPU"
jeffhao5d1ac922011-09-29 17:41:15 -0700139 ) 1>&2
140 exit 1
141fi
142
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700143if [ "$sequental" == "yes" ]; then
144 i=0
145 for test_name in *; do
146 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
147 ./run-test ${run_args} "$test_name"
148 RES=$?
149 test_pids[i]=i
150 test_names[test_pids[i]]="$test_name"
151 if [ "$RES" != "0" ]; then
152 let failure_count+=1
153 failed_test_names="$failed_test_names ${test_names[i]}"
154 else
155 let succeeded_count+=1
156 fi
157 let i+=1
158 fi
159 done
160else
161 # start all the tests
162 i=0
163 for test_name in *; do
164 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
165 ./run-test ${run_args} "$test_name" &
166 test_pids[i]=$!
167 test_names[test_pids[i]]="$test_name"
168 let i+=1
169 fi
170 done
jeffhao5d1ac922011-09-29 17:41:15 -0700171
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700172 # wait for all the tests, collecting the failures
173 failure_count=0
174 succeeded_count=0
175 failed_test_names=""
176 for pid in ${test_pids[@]}; do
177 wait $pid
178 if [ "$?" != "0" ]; then
179 let failure_count+=1
180 failed_test_names="$failed_test_names ${test_names[$pid]}[pid=$pid]"
181 else
182 let succeeded_count+=1
183 fi
184 done
185fi
jeffhao5d1ac922011-09-29 17:41:15 -0700186
TDYa127b92bcab2012-04-08 00:09:51 -0700187echo "succeeded tests: $succeeded_count"
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700188echo "failed tests: $failure_count"
189
190for i in $failed_test_names; do
191 echo "failed: $i"
jeffhao5d1ac922011-09-29 17:41:15 -0700192done